<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2005 Coppermine Dev Team
  v1.1 originally written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  ********************************************
  Coppermine version: 1.4.2
  $Source: /cvsroot/coppermine/devel/bridge/punbb12.inc.php,v $
  $Revision: 1.13 $
  $Author: gaugau $
  $Date: 2005/10/25 01:16:09 $
**********************************************/

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');

// Switch that allows overriding the bridge manager with hard-coded values
define('USE_BRIDGEMGR', 0);

require 'bridge/udb_base.inc.php';

class cpg_udb extends core_udb {

	function cpg_udb()
	{
		global $BRIDGE;
		
		if (!USE_BRIDGEMGR) { // the vars that are used when bridgemgr is disabled
			// local path to your mytopix config file
			$path = '../mytopix/';
			$this->use_post_based_groups = 0;
		} else { // the vars from the bridgemgr
			$path = $BRIDGE['relative_path_to_config_file'];
			$this->use_post_based_groups = $BRIDGE['use_post_based_groups'];
		}
		 
		require_once $path . 'init.php';
		define('SYSTEM_PATH', $path);
		define('DEBUG', false);
        require_once SYSTEM_PATH . 'config/settings.php';
		require_once SYSTEM_PATH . 'config/constants.php';
		require_once SYSTEM_PATH . 'lib/db/database.db.php';
		require_once SYSTEM_PATH . "lib/db/{$config['db_type']}.db.php";
		require_once SYSTEM_PATH . 'lib/cookie.han.php';
		
		// Reason for this is that board uses same defines() as us and uses them differently.
		//require_once SYSTEM_PATH . 'lib/user.han.php';
		$file = file_get_contents(SYSTEM_PATH . 'lib/user.han.php');
		$find = array('USER_ID', 'USER_GROUP', '<?php');
		$replace = array('USER_ID_2', 'USER_GROUP_2', '');
		$file = str_replace($find, $replace, $file);
		eval($file);
		
		require_once SYSTEM_PATH . 'lib/cache.han.php';
		
		$this->config = $config;
		$this->boardurl = rtrim($config['site_link'], '/');
			
		$this->CookieHandler = new CookieHandler($this->config, $_COOKIE);
		$db_handler_name = $this->config['db_type'] . 'Handler';
		 
		$this->DatabaseHandler = new $db_handler_name($this->config['db_host'], $this->config['db_port']);
		$this->DatabaseHandler->doConnect($this->config['db_user'], $this->config['db_pass'],$this->config['db_name'],$this->config['db_persist']);
		$this->CacheHandler = new CacheHandler($this->DatabaseHandler, null);
		$this->UserHandler  = new UserHandler($this);
		$this->UserHandler->fetchUser($this->CookieHandler->getVar('id'), $this->CookieHandler->getVar('pass'));
		
		$this->multigroups = 0;
		$this->group_overrride = 0;
		
		// Database connection settings
		$this->db = array(
			'name' => $this->config['db_name'],
			'host' => $this->config['db_host'],
			'user' => $this->config['db_user'],
			'password' => $this->config['db_pass'],
			'prefix' =>$this->config['db_pref']
		);
		
		// Board table names
		$this->table = array(
			'users' => 'members',
			'groups' => 'class',
		);

		// Derived full table names
		$this->usertable = '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['users'];
		$this->groupstable =  '`' . $this->db['name'] . '`.' . $this->db['prefix'] . $this->table['groups'];
		
		// Table field names
		$this->field = array(
			'username' => 'members_name', // name of 'username' field in users table
			'user_id' => 'members_id', // name of 'id' field in users table
			'password' => 'members_pass', // name of 'password' field in users table
			'email' => 'members_email', // name of 'email' field in users table
			'regdate' => 'members_registered', // name of 'registered' field in users table
			'location' => 'members_location', // name of 'location' field in users table
			'website' => 'members_homepage', // name of 'website' field in users table
			'usertbl_group_id' => 'members_class', // name of 'group id' field in users table
			'grouptbl_group_id' => 'class_id', // name of 'group id' field in groups table
			'grouptbl_group_name' => 'class_title' // name of 'group name' field in groups table
		);
		
		// Pages to redirect to
		$this->page = array(
			'register' => '/index.php?a=register',
			'editusers' =>  '/index.php?a=members',
			'edituserprofile' => '/index.php?a=ucp&CODE=00'
		);
		
		// Group ids
		$this->admingroups = array(3);
		$this->guestgroup = 1;
		
		// Connect to db
		$this->connect();
	}

function authenticate()
	{
		global $USER_DATA, $user_settings;

		$uid = $this->UserHandler->getField('members_id');
		
		if ($uid <= 1){
			$this->load_guest_data();
		} else {
		
			$row = array(
				'id' => $uid,
				'username' => $this->UserHandler->getField('members_name'),
				'group_id' => $this->UserHandler->getField('members_class') +100,
			);
		
			$this->load_user_data($row);
		}

		$user_group_set = '(' . implode(',', $USER_DATA['groups']) . ')';

        $USER_DATA = array_merge($USER_DATA, $this->get_user_data($USER_DATA['groups'][0], $USER_DATA['groups'], $this->guestgroup));

		if ($this->use_post_based_groups){
			$USER_DATA['has_admin_access'] = (in_array($USER_DATA['groups'][0] - 100,$this->admingroups)) ? 1 : 0;
		} else {
			$USER_DATA['has_admin_access'] = ($USER_DATA['groups'][0] == 1) ? 1 : 0;
		}
		
		$USER_DATA['can_see_all_albums'] = $USER_DATA['has_admin_access'];
		
		// avoids a template error
		if (!$USER_DATA['user_id']) $USER_DATA['can_create_albums'] = 0;
		
	    // For error checking
		$CONFIG['TABLE_USERS'] = '**ERROR**';

		define('USER_ID', $USER_DATA['user_id']);
        define('USER_NAME', addslashes($USER_DATA['user_name']));
        define('USER_GROUP', $USER_DATA['group_name']);
        define('USER_GROUP_SET', $user_group_set);
        define('USER_IS_ADMIN', $USER_DATA['has_admin_access']);
        define('USER_CAN_SEND_ECARDS', (int)$USER_DATA['can_send_ecards']);
        define('USER_CAN_RATE_PICTURES', (int)$USER_DATA['can_rate_pictures']);
        define('USER_CAN_POST_COMMENTS', (int)$USER_DATA['can_post_comments']);
        define('USER_CAN_UPLOAD_PICTURES', (int)$USER_DATA['can_upload_pictures']);
        define('USER_CAN_CREATE_ALBUMS', (int)$USER_DATA['can_create_albums']);
        define('USER_UPLOAD_FORM', (int)$USER_DATA['upload_form_config']);
        define('CUSTOMIZE_UPLOAD_FORM', (int)$USER_DATA['custom_user_upload']);
        define('NUM_FILE_BOXES', (int)$USER_DATA['num_file_upload']);
        define('NUM_URI_BOXES', (int)$USER_DATA['num_URI_upload']);
		
		$this->session_update();
		
	}
	
	// Login
	function login_page()
	{
		$this->redirect('/index.php?a=logon');
	}

	// Logout
	function logout_page()
	{
		$this->redirect('/index.php?a=logon&CODE=02');
	}
	
	function view_users()
	{
		if (!$this->use_post_based_groups) $this->redirect($this->page['editusers']);
	}
	
	    function get_users($options = array())
    {
    	global $CONFIG;

		// Copy UDB fields and config variables (just to make it easier to read)
    	$f =& $this->field;
		$C =& $CONFIG;
		
		// Sort codes
        $sort_codes = array('name_a' => 'user_name ASC',
                            'name_d' => 'user_name DESC',
                            'group_a' => 'group_name ASC',
                            'group_d' => 'group_name DESC',
                            'reg_a' => 'user_regdate ASC',
                            'reg_d' => 'user_regdate DESC',
                            'pic_a' => 'pic_count ASC',
                            'pic_d' => 'pic_count DESC',
                            'disku_a' => 'disk_usage ASC',
                            'disku_d' => 'disk_usage DESC',
                            'lv_a' => 'user_lastvisit ASC',
                            'lv_d' => 'user_lastvisit DESC',
                           );

        // Fix the group id, if bridging is enabled
        if ($CONFIG['bridge_enable']) {
            $f['usertbl_group_id'] .= '+100';
        }
        
		// Build WHERE clause, if this is a username search
        if ($options['search']) {
            $options['search'] = 'AND u.'.$f['username'].' LIKE "'.$options['search'].'" ';
        }

		// Build SQL table, should work with all bridges
        $sql = "SELECT {$f['user_id']} as user_id, {$f['username']} as user_name, {$f['email']} as user_email, {$f['regdate']} as user_regdate, last_visit as user_lastvisit, '' as user_active, ".
               "COUNT(pid) as pic_count, ROUND(SUM(total_filesize)/1024) as disk_usage, group_name, group_quota ".
               "FROM {$this->usertable} AS u ".
               "INNER JOIN {$C['TABLE_USERGROUPS']} AS g ON u.{$f['usertbl_group_id']} = g.group_id ".
               "LEFT JOIN {$C['TABLE_PICTURES']} AS p ON p.owner_id = u.{$f['user_id']} WHERE {$f['user_id']} > 1 ".
               $options['search'].
               "GROUP BY user_id " . "ORDER BY " . $sort_codes[$options['sort']] . " ".
               "LIMIT {$options['lower_limit']}, {$options['users_per_page']};";

		$result = cpg_db_query($sql);
		
		// If no records, return empty value
		if (!$result) {
			return array();
		}
		
		// Extract user list to an array
		while ($user = mysql_fetch_assoc($result)) {
			$userlist[] = $user;
		}	

        return $userlist;
    }
	
	function view_profile($uid)
	{
	}
}



// and go !
$cpg_udb = new cpg_udb;
?>
